<script lang="ts">
    import Sortable from 'sortablejs'
    import {createEventDispatcher, onMount} from "svelte"
    import Todo from "./Todo.svelte"

    const dispatch = createEventDispatcher()
    export let todos: Array<{ _id: string; title: string; completed: boolean; position: number }>

    export let highlight

    let sortableElement

    onMount(() => {
        Sortable.create(sortableElement, {
            group: "todos",
            animation: 250,
            delay: 300,
            delayOnTouchOnly: true,
            store: {
                get: () => todos.map((todo) => todo._id),
                set: (sortable: Array<string>) => dispatch("sorted", { order: sortable.toArray() })
            },
            onAdd: function(event) {
                dispatch("added", { id: event.item.dataset.id })
            }
        })
    })
</script>

<div class="todo-list" bind:this={sortableElement}>
    {#each todos as todo (todo._id)}
        <div class="todo-item card" data-id={todo._id}>
            <Todo todo={todo} highlight={highlight} on:change on:delete />
        </div>
    {/each}
</div>

<style>
    .todo-list {
        height: 100%;
    }

    .todo-item {
        margin-bottom: 0.7rem;
    }
</style>